
namespace Glyph {

  class Glyph {
  public:
    virtual void draw (Window* w) = 0;
    virtual bool intersects (Point* p) = 0;
  };

  class Char : public Glyph {
  protected:
    char c;
  public:
    Char(char c);
    void draw (Window* w);
    bool intersects (Point* p);
  };

  class CompositeGlyph : public Glyph {
  // Operations
  public:
    virtual void addChild (Glyph* g) = 0;
    virtual Glyph* getChild (int i) = 0;
  };

  class HBox : public CompositeGlyph {
  protected:
    std::vector<Glyph*> children;
  public:
    HBox();
    void draw (Window* w);
    bool intersects (Point* p);
    void addChild (Glyph* g);
    Glyph* getChild (int i);
  };

};
